/***** watterson.c ***********************************************************
 * Description: Implement Watterson's equation.
 * Author: Bernhard Haubold, bernhard.haubold@fh-weihenstephan.de
 * File created on Wed Apr 25 11:20:41 2007.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA.
 *****************************************************************************/
#include <stdio.h>
#include <math.h>
#include "interface.h"
#define GAMMA 0.577215664901532

int main(int argc, char *argv[]){
  Args args;               /* arguments */
  char *version = "0.2";   /* program version */
  int i;
  double h, s;
  
  args = getArgs(argc, argv);

  if(args.h == 1){
    printUsage(version);
    return 0; 
  }else if(args.e == 1){
    printUsage(version);
    return -1;
  }
  /* compute harmonic number */
  if(args.a)
    s = args.t * (log(args.n) + GAMMA);
  else{
    h = 0;
    for(i=1;i<args.n;i++){
      h += 1.0/(double)i;
    }
    s = args.t * h;
  }

  printf("S = %f\n",s);
}
